#ifndef __COMMON1__
#define __COMMON1__

/* make a log entry */

V writelog(C *s)
  {
    if(logname[0]!='\0')
      fwritelog(logname,s);	
  }

V fwritelog(C *f, C *s)
  {
    FILE  *fh;
    time_t now;
    S	   tm *tm;
    SI	   h;
    STR    d1, ap;
    UL	   x, day;

    if(f[0]!='\0')
      {
        fh=fopen(f,"a+");	

	now=time(NULL);
	day=((now/60)/60)/24;
	tm=localtime(&now);

	h=tm->tm_hour;
	if(h==0)
	  {
	    h=12;
	    dstrcopy(ap,"AM");
	  }
	else
	  if(h<12)
	    dstrcopy(ap,"AM");
	  else
	    {
	      h-=12;
	      if(h==0)
		h=12;
	      dstrcopy(ap,"PM");
	    }

        sprintf(d1,"%02i/%02i/%02i %2i:%02i %s  %s\n",tm->tm_mon+1,tm->tm_mday,
          tm->tm_year-100,h,tm->tm_min,ap,s);

	fputs(d1,fh);

	fclose(fh);
      }
  }

/* check to see if file exists */

SI exist(C *s)
  {
    if(access(s,R_OK)==0)
      return(TRUE);
    else
      return(FALSE);
  }

/* Return a substring of a string */

C *substr(C *d, C *s, UL start, UL end)
  {
    UL i, j;

    if(!*s)
      return(d=s);

    if(start==0)
      start=1;

    memcpy(d,&s[start-1],(end-start)+1);
    d[(end-start)+1]='\0';

    return(d);
  }

/* Copy a string to a new variable */

C *dstrcopy(C *d, C *s)
  {
    UL l;

    if(!*s)
      {
	d[0]='\0';
	return(d);
      }

    for(l=0;s[l]!='\0';l++)
      d[l]=s[l];
    d[l]='\0';

    return(d);
  }

/* Convert string to long */

L s2l(C *s)
  {
    L   i=0,n,sign;
    STR d;

    trim(d,s);

    sign=(s[i]=='-')?-1:1;
    if(s[i]=='-')
      i++;
    for(n=0; ifdigit((C) s[i]); i++)
      n=10*n+(s[i]-'0');

    return(sign*n);
  }

/* Convert L-> C */

C *l2s(C *d, L n)
  {
    L i,sign;

    if ((sign=n)<0)
      n=-n;
    i=0;
    do
      {
	d[i++]=n%10+'0';
      } while((n/=10)>0);
    if(sign<0)
      d[i++]='-';
    d[i]='\0';

    dstrrev(d);

    return(d);
  }

/* Convert L2 -> C */

C *ll2s(C *d, L2 n)
  {
    L  i;
    L2 sign;

    if ((sign=n)<0)
      n=-n;
    i=0;
    do
      {
	d[i++]=n%10+'0';
      } while((n/=10)>0);
    if(sign<0)
      d[i++]='-';
    d[i]='\0';

    dstrrev(d);

    return(d);
  }

/* Is the character a number */

I ifdigit(C c)
  {
    if(c>='0' && c<='9')
      return(TRUE);
    else
      return(FALSE);
  }

/* Reverse a string */

C *dstrrev(C *s)
  {
    UL i, j, l;
    C  c;

    if(!*s)
      return(s);

    l=dstrlen(s);

    for(i=0,j=l-1; i<j; i++,j--)
      {
	c=s[i];
	s[i]=s[j];
	s[j]=c;
      }

    return(s);
  }

/* Return position of substr in C starting from the end */

UL rpos(C *srch, C *s)
  {
    STR srch2;
    L	i, ls, l, x, y;
    I	found=FALSE;
    C	d;

    if(!*s)
      return(FALSE);

    l=dstrlen(s);

    ls=dstrlen(srch);
    i=dstrlen(s)-ls;

    for(x=0;srch[x]!='\0';x++)
      if((srch[x]>='a') && (srch[x]<='z'))
        srch2[x]=srch[x]-32;
      else    
        srch2[x]=srch[x];

    while(found!=TRUE && i>-1)
      {
	x=0;
	do
	  {
	    d=s[i+x];
	    if((d>='a') && (d<='z'))
	      d-=32;
	    found=(d==srch2[x]);
	    x++;
	  } while(x<ls && found!=FALSE);

	i--;
      }

    if(found==TRUE)
      return(i);
    else
      return(l);
  }

/* Return position of substr in C */

UL pos(C *srch, C *s)
  {
    return(cpos(srch,s,0));
  }

UL cpos(C *srch, C *s, L start)
  {
    STR srch2;
    L	i, l, ls, x, y;
    I	found=FALSE;
    C	d;

    if(!*s)
      return(0);

    l=dstrlen(s);
    ls=dstrlen(srch);

    if(ls>l)
      return(0);

    for(x=0;srch[x]!='\0';x++)
      if((srch[x]>='a') && (srch[x]<='z'))
        srch2[x]=srch[x]-32;
      else    
        srch2[x]=srch[x];

    i=start;

    while(found!=TRUE && i<l)
      {
	x=0;
	do
	  {
	    d=s[i+x];
	    if((d>='a')&&(d<='z'))
	      d-=32;
	    found=(d==srch2[x]);
	    x++;
	  } while(x<ls && found!=FALSE);

	i++;
      }

    if(found==TRUE)
      return(i);
    else
      return(0);
  }

/* Compare w/ no case */

US dstrcmp(C *s1, C *s2)
  {
    UL	i, l;
    C	d1, d2;

    if(!*s1)
      return(FALSE);

    for(i=0;s1[i]!='\0' && s2[i]!='\0';i++)
      {
	d1=s1[i];
	if((d1>='a')&&(d1<='z'))
	  d1-=32;

	d2=s2[i];
	if((d2>='a')&&(d2<='z'))
	  d2-=32;

	if(d1!=d2)
	  return(FALSE);
      }

    d1=s1[i];
    if((d1>='a') && (d1<='z'))
      d1-=32;

    d2=s2[i];
    if((d2>='a') && (d2<='z'))
      d2-=32;

    if(d1!=d2)
      return(FALSE);

    return(TRUE);
  }

/* Trim leading and trailing spaces */

C *trim(C *d, C *s)
  {
    C  xx[65536];

    if(!*s)
      {
	d[0]='\0';
	return(d);
      }

    ltrim(xx,s);

    if(!*xx)
      {
	d[0]='\0';
	return(d);
      }

    rtrim(d,xx);

    return(d);
  }

/* Trim trailing spaces */

C *rtrim(C *d, C *s)
  {
    UL i, j, l;

    if(s[0]=='\0')
      {
	d[0]='\0';
	return(d);
      }

    l=dstrlen(s);

    for(i=l-1; (s[i]==' ' || s[i]=='\t') && i>0; i--);

    if(i>0)
      left(d,s,i+1);
    else
      {
	if(s[0]!=' ')
	  {
	    d[0]=s[0];
	    d[1]='\0';
	  }
	else
	  d[0]='\0';
      }

    return(d);
  }

/* Trim leading spaces */

C *ltrim(C *d, C *s)
  {
    UL i=0, j, l;

    if(!*s)
      return(d=s);

    for(i=0; (s[i]==' ' || s[i]=='\t') && s[i]!='\0'; i++);

    if(s[i]=='\0')
      {
	d[0]='\0';
	return(d);
      }

    for(j=0;s[i]!='\0';j++,i++)
      d[j]=s[i];
    d[j]='\0';

    return(d);
  }

/* Return a substr of string */

C *right(C *d, C *s, UL n)
  {
    UL i, j, l;

    if(!*s)
      return(d=s);

    l=dstrlen(s);

    if(n>l)
      return(d=s);

    memcpy(d,&s[l-n],n);
    d[n]='\0';

    return(d);
  }

/* Return a substr of string */

C *left(C *d, C *s, UL n)
  {
    UL i, l;

    if(!*s)
      return(d=s);

    l=dstrlen(s);

    if(n>l)
      return(d=s);

    memcpy(d,s,n);
    d[n]='\0';

    return(d);
  }

/* Return the length of a string */

UL dstrlen(C *s)
  {
    UL i;

    for(i=0; s[i]!='\0'; i++);

    return(i);
  }

/* Produce a duplicated string set */

C *dupstr(C *d, C ch, UL n)
  {
    memset(d,ch,n);
    d[n]='\0';

    return(d);
  }

/* Concatinate strings */

C *dstrcat(C *d, C *s, ...)
  {
    va_list str;
    UL	    i, j, l1=0, l2;
    C	   *temp;

    va_start(str, s);

    temp=s;
    while(temp)
      {
	if(temp)
	  {
	    for(i=0;temp[i]!='\0';i++)
	      d[l1++]=temp[i];
	  }

	temp=va_arg(str, char *);
      }

    d[l1]='\0';

    return(d);
  }

#endif