/*
   Common declarations used all the time
   Written for GNU C 2.7.2.1

   Copyright (C) 1990-1999 Alecia & Bobby Darin
   All Rights Reserved.

   This work is protected under the GNU Public License.  IT MAY NOT BE SOLD
   FOR PROFIT

   Many thanks to Lodewijk Voge for streamlining much of this code 
*/

#ifndef __COMMON__
#define __COMMON__

/* mandatory includes */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/resource.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <dirent.h>
#include <limits.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

/* type defs */

typedef unsigned char		    string[256];
typedef unsigned char		    textline[81];

/* Common headers to simplify typing */

#define C			    unsigned char
#define D			    double
#define F			    float
#define I			    int
#define L			    long
#define L2			    long long
#define LD			    long double
#define S			    struct
#define SC			    signed char
#define SI			    int
#define STR			    string
#define TEXT			    textline
#define U			    union
#define UC			    unsigned char
#define UI			    unsigned int
#define UL			    unsigned long
#define US			    unsigned short
#define V			    void

/* for conditionals */

#ifndef
 FALSE
#define FALSE			    0
#endif

#ifndef TRUE
#define TRUE			    1
#endif

#define ONEDAY                      86400

/* File Portabiliity from DJGPP/TC -> GCC */

#define sopen(path,access,shflag,mode) 	open((path),(access)|(shflag),(mode))

/* not needed under linux, under DOS, there is a difference in the way DJGPP */
/* and TC do things */

#define vio_bios_gotoxy         	vio_gotoxy

/* DJGPP -> GCC */

#define SH_COMPAT       0x0000
#define SH_DENYRW       0x0010
#define SH_DENYWR       0x0020
#define SH_DENYRD       0x0030
#define SH_DENYNO       0x0040

#define S_IREAD         S_IRUSR
#define S_IWRITE        S_IWUSR
#define S_IEXEC         S_IXUSR

/* Global Variables */

U                                                                           
  {                                                                             
    I  ni;                                                            
    L  nl;                                                           
    L2 nll;                                                       
    C  string[8];                                                       
  } c2b_data;                                                                   
                    
/* needed for properdate */

C *monthname[]={"January","February","March","April","May","June","July",
		"August","September","October","November","December"};

STR pfile;		   /* location of proper case file */
STR logname;		   /* log file name */
STR home;                  /* where is our home? */
STR user;                  /* who are we? */
pid_t pid;
C   strpid[7], pids[7];

STR WebItem[127];          /* Variables for the form fields in as CGI */
C  *WebData[127];
I   WebCount=0;

/* Prototypes */

C *dstrcat(C *d, C *s, ...);
C *dstrcopy(C *d, C *s);
C *dstrrev(C *s);
C *dupstr(C *d, C ch, UL n);
C *l2s(C *d, L n);
C *left(C *d, C *s, UL n);
C *ll2s(C *d, L2 n);
C *ltrim(C *d, C *s);
C *rtrim(C *d, C *s);
C *substr(C *d, C *s, UL start, UL end);
C *trim(C *d, C *s);
I  ifdigit(C c);
L  s2l(C *s);
SI exist(C *s);
UL cpos(C *srch, C *s, L start);
UL dstrlen(C *s);
UL pos(C *srch, C *s);
UL rpos(C *srch, C *s);
US dstrcmp(C *s1, C *s2);
V  fwritelog(C *f, C *s);
V  writelog(C *s);

#endif
